#ifndef INCLUDED_CURVE_EVALUATORS_H
#define INCLUDED_CURVE_EVALUATORS_H

#pragma warning(disable : 4786)  

#include <string>

#include <map>

#include "Singleton.h"

class CurveEvaluator;

class CurveEvaluators : public Singleton<CurveEvaluators>
{
	public:

		~CurveEvaluators(void);

		void addCurveEvaluator(const std::string & curve_name, CurveEvaluator * curve_evaluator);

		CurveEvaluator * getCurveEvaluator(const std::string & curve_name) const;

		typedef std::map<std::string, CurveEvaluator *> CurveNameEvaluatorMapping;

		typedef CurveNameEvaluatorMapping::const_iterator const_iterator;

		CurveNameEvaluatorMapping::const_iterator begin(void) const;
		CurveNameEvaluatorMapping::const_iterator end(void) const;

	private:

		void cleanupCurveEvaluators(void);

		CurveNameEvaluatorMapping m_curve_name_evaluator_mapping;

};

#endif